<?php

/**
 * ZboziExportQueue sorts items by item_id during claiming items.
 * It helps to process the items in the right order.
 *
 * @author Vojtech Kusy <wojtha@gmail.com>
 */
class ExporterQueue extends SystemQueue {

  public function claimItem($lease_time = 30) {
    // Claim an item by updating its expire fields. If claim is not successful
    // another thread may have claimed the item in the meantime. Therefore loop
    // until an item is successfully claimed or we are reasonably sure there
    // are no unclaimed items left.
    while (TRUE) {
      $item = db_fetch_object(db_query_range('SELECT data, item_id FROM {queue} q WHERE expire = 0 AND name = "%s" ORDER BY created ASC, item_id ASC', $this->name, 0, 1));
      if ($item) {
        // Try to update the item. Only one thread can succeed in UPDATEing the
        // same row.
        db_query('UPDATE {queue} SET expire = %d WHERE item_id = %d AND expire = 0', EXPORTER_NOW + $lease_time, $item->item_id);
        // If there are affected rows, this update succeeded.
        if (db_affected_rows()) {
          $item->data = unserialize($item->data);
          return $item;
        }
      }
      else {
        // No items currently available to claim.
        return FALSE;
      }
    }
  }

}
