<?php
/**
 * Author: Vojtěch Kusý <vojtech.kusy@gmail.com> 
 * Date: 18.7.13
 * Time: 17:13
 */


class NodeExporter extends Exporter {

  protected $object_cache_exists;

  function __construct($id) {
    parent::__construct($id);
    $this->object_cache_exists = module_exists('object_cache');
  }

  function getItemId($item) {
    return $item->nid;
  }

  function getCount() {
    return (int) db_result(db_query("SELECT COUNT(nid) FROM {node} WHERE status = 1"));
  }

  function getItemIds($offset, $per_page) {
    $items = array();

    $result = db_query_range("SELECT nid FROM {node} WHERE status = 1 ORDER BY nid ASC", $offset, $per_page);
    while ($row = db_fetch_object($result)) {
      $items[$row->nid] = $row->nid;
    }

    return $items;
  }

  function loadItem($nid) {
    return $this->object_cache_exists ? object_cache_get('node', $nid) : node_load($nid);
  }

  function renderHeader() {
    throw new BadMethodCallException(get_class($this) . '->' . __FUNCTION__ . ' method is not implemented.');
  }

  function renderItem($node) {
    throw new BadMethodCallException(get_class($this) . '->' . __FUNCTION__ . ' method is not implemented.');
  }

  function renderFooter() {
    throw new BadMethodCallException(get_class($this) . '->' . __FUNCTION__ . ' method is not implemented.');
  }

}
