<?php
/**
 * Author: Vojtěch Kusý <vojtech.kusy@gmail.com> 
 * Date: 22.7.13
 * Time: 16:30
 */

class UserExporter extends Exporter {

  protected $object_cache_exists;

  function __construct($id) {
    parent::__construct($id);
    $this->object_cache_exists = module_exists('object_cache');
  }

  function getItemId($item) {
    return $item->uid;
  }

  function getCount() {
    return (int) db_result(db_query("SELECT COUNT(uid) FROM {users}"));
  }

  function getItemIds($offset, $per_page) {
    $items = array();

    $result = db_query_range("SELECT uid FROM {users} ORDER BY uid ASC", $offset, $per_page);
    while ($row = db_fetch_object($result)) {
      $items[$row->uid] = $row->uid;
    }

    return $items;
  }

  function loadItem($uid) {
    return $this->object_cache_exists ? object_cache_get('user', $uid) : user_load($uid);
  }

  function renderHeader() {
    throw new BadMethodCallException(get_class($this) . '->' . __FUNCTION__ . ' method is not implemented.');
  }

  function renderItem($node) {
    throw new BadMethodCallException(get_class($this) . '->' . __FUNCTION__ . ' method is not implemented.');
  }

  function renderFooter() {
    throw new BadMethodCallException(get_class($this) . '->' . __FUNCTION__ . ' method is not implemented.');
  }

}
